-------------------------------------------------------------------------------
--! @file       L_DRAM.vhd
--! @author     William Diehl
--! @brief      OMD L_DRAM
--! @date       29 July 2016
-------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
USE ieee.std_logic_unsigned.all;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity L_DRAM is

generic( 
	 addr_width : integer:=3;
	 n : integer:=256 );
PORT(
      clk:IN STD_LOGIC;
		we: IN STD_LOGIC;
		di: IN STD_LOGIC_VECTOR(n-1 downto 0);
		do: OUT STD_LOGIC_VECTOR(n-1 downto 0);
		addr:IN STD_LOGIC_VECTOR(addr_width-1 downto 0)
		);
end L_DRAM;

architecture behavioral of L_DRAM is
type ram_type is array (0 to 2**addr_width - 1 ) of std_logic_vector(n-1 downto 0);
signal RAM:ram_type :=(others=>(others=>'0'));
begin
  process(clk)
   begin
      if rising_edge(clk) then
		  if (we='1')then
		    RAM(to_integer(unsigned(addr)))<=di;
		  end if;
		 end if;
		end process;
	 do<= RAM(to_integer(unsigned(addr)));
end behavioral;

