-------------------------------------------------------------------------------
--! @file       Sigma0.vhd
--! @author     William Diehl
--! @brief      OMD Sigma0
--! @date       29 July 2016
-------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

entity Sigma0 is
generic( 
	n 		: integer :=32 		-- size of basic operation
	);
port(
	x		:in std_logic_vector(n-1 downto 0);
	o		:out std_logic_vector(n-1 downto 0));
end Sigma0;

architecture dataflow of Sigma0 is
begin										  
			
	o <= (x(1 downto 0) & x(n-1 downto 2))
	xor (x(12 downto 0) & x(n-1 downto 13))
	xor (x(21 downto 0) & x(n-1 downto 22));
						
end dataflow;
